<?php
/**
 * compare.php -
 *
 * Unit compare controller. This code needs a lot of work since it was not implemented professionally.
 * This is very messy and a lot of ad-hoc data structures. Also, very diffcult to modify when we modify the
 * unit page or the unitmain template engine. But, it does work for now.
 *
 * @author $Author: dtong $
 * @version $Id: compare.php,v 1.33 2012/03/20 08:34:19 dtong Exp $
 * @copyright Copyright (c) 2009, Tiller Software Co., Ltd.
*/
require_once(APPPATH . 'libraries/mapping/display_list.php');

class Compare extends CI_Controller{
	private $old_history = FALSE;

	function __construct() {
		parent::__construct();
		$this->access_model->checkaccess_all(array('unit_read','non_guest_access'));
		$this->load->helper('form');
		// $this->load->helper('date');
		osa_load_lang('unit');
		osa_load_lang('general');
		// $this->load->library('form_validation');
		$this->load->library('unit/compare/unit_compare');
		$this->load->model('unit/unit_model');
		$this->load->model('sort/searchsort_model');
	}

	// Compare supplied unitid against its current published unit.
	function current($unitid=FALSE) {
		if (!isset($unitid) || !is_numeric($unitid) ) {
			echo lang('unit_no_permissionmsg');
			return FALSE;
		}

		$unit = $this->unit_model->get_unit_any($unitid);
		$current = $this->unit_model->get_last_version($unit);

		if (!isset($current) || !isset($current->id) || !is_numeric($current->id) ) {
			echo lang('unit_no_permissionmsg');
			return FALSE;
		}

		$this->version($unitid, $current->id);

		return FALSE;
	}

   function history($unitid, $isParent=FALSE) {
   	$display = new display_list();
   	if ($isParent !==FALSE) {
   		 $display->formname = 'unit_parent_history_form';
   	}
   	else {
   		 $display->formname = 'unit_history_form';
   	}

		$display->image_sort = 1;
		$display->default_col = 0;
		$display->divid = $display->formname ;
		$display->searchid = $display->formname ;
		$display->titles = array(lang('unit_history_col_revision'),
										 lang('unit_history_col_revisiontime'),
										 lang('unit_history_col_select')
								 );
		$display->widths = array('40%', '50%', '10%');

		$data_group = $this->unit_model->get_unit_any($unitid);
		$data  = $this->unit_model->get_unit_history($data_group,TRUE);

		$display->unit = $this->unit_model->get_parentinfo($unitid);
		//$display->unit->unit = $this->unit_model->get_unit($unitid);
		if (isset($data) &&  $data !== FALSE) {
			foreach ($data as $key => $rows) {
				if (isset($rows) && $rows != FALSE) {
					$unitid = $rows->id;//$rows->id;
					$checked = '';
					$version = $rows->version;
					$modifydate = osa_date_format($rows->modifydate);
					if ($rows->version < 10) {
						$version = '0'.$rows->version;
					}

					if ($rows->version == null || $rows->version == '') {
						$css = '';
						if (isset($rows->status) && $rows->status ==  CMS_UNIT_STATUS_PUBLISH) {
							$css = 'class="unit_history_current"';
							$version = lang('unit_history_current');
						}
						else if (isset($rows->status) && $rows->status == CMS_UNIT_STATUS_EDIT) {
							$css = 'class="unit_history_editting"';
							$version = lang('unit_history_editting');
						}

						$version = '<span '.$css.'>'. $version . '</span>';
						$modifydate = '<span '.$css.'>'.$modifydate. '</span>';
					}
					else {
						$version = $version;
						$modifydate = $modifydate;
					}
					$checked = form_checkbox('unitid[]', $unitid, FALSE, '');

					$temp = array($version, "$modifydate", $checked);
					$display->add($temp);
				}
			}
		}
		$display->column_data_align[0] = 'center';
		$display->column_data_align[1] = 'center';
		$display->column_data_align[2] = 'center';
		$display->allpage = TRUE;
	  	//$display->iswindow = FALSE;
		$display->force_sort = TRUE;
		$display->default_col = 1;
		$display->sort_direction = display_list::SORT_DESC;
      $display->prepare_page();
      $data = new stdClass();
      $data->display = $display;
      echo $this->load->view('tablelist/unithistory_list_view', $data, TRUE);
      // Do exit so no security upate to run in the post controller.
      exit;
    }

    // The shows the compare result window with 2 units side-by-side. There are 3 ways to call this function.
    // 1. With 2 unitids on the URL.
    // 2. Submit a bunch of checkbox selections - only 2 is allowed. This is from the history window.
    // 3. Select a different version from the compare result window generated by this function.
	function version($unitid_left=FALSE, $unitid_right=FALSE, $show_dropdowns=TRUE) {
		$too_many_selections = FALSE;
		if ( isset($_REQUEST['unitid']) && is_array($_REQUEST['unitid']) && count($_REQUEST['unitid']) >= 2 ) {
			// This is for the history page with many check boxes. This is "2".
			// We have many empty selections so weed them out.
			foreach ($_POST['unitid'] as $current_id) {
				if ( osa_is_int_one($current_id) ) {
					if ( $unitid_left === FALSE ) {
						$unitid_left = $current_id;
					}
					elseif ( $unitid_right === FALSE ) {
						$unitid_right = $current_id;
					}
					else {
						// This happens when user selects more than 2 versions.
						$too_many_selections = TRUE;
						break;
					}
				}
			}
		}
		elseif ( isset($_REQUEST['unitid_left']) && isset($_REQUEST['unitid_right']) ) {
			// This is for selecting a different version from the 2 dropdowns located on the compare result window.
			// This is "3".
			$unitid_left  = $_REQUEST['unitid_left'];
			$unitid_right = $_REQUEST['unitid_right'];
			$show_dropdowns = FALSE;
		}
		// "1" just uses the ids from the URL which is what the code above try to make it look like "1".
		// This checks for 1,2 and 3.
		if ( !osa_is_int_one($unitid_left) || !osa_is_int_one($unitid_right) || $too_many_selections ){
			echo osa_ajaxmsg(lang('unit_history_massage_req'));
			exit;
		}

		// Gets the unit title,description etc and puts the object in $data->unit.
		$data_left = $this->unit_compare->get_viewdata($unitid_left, TRUE);
		if (!is_object($data_left->unit)) {
			//$data_left = FALSE;
			exit;
		}
		$data_right = $this->unit_compare->get_viewdata($unitid_right, TRUE);
		if (!is_object($data_right->unit)) {
			//$data_right = FALSE;
			exit;
		}

		if ( ($data_left->unit->status != CMS_UNIT_STATUS_EDIT && $data_left->unit->status != CMS_UNIT_STATUS_PUBLISH) ||
			  ($data_right->unit->status != CMS_UNIT_STATUS_EDIT && $data_right->unit->status != CMS_UNIT_STATUS_PUBLISH) ) {
			// If any one of the 2 units is an old unit then inlineobj needs to know it is comparing to a unit
			// with uploads not avaiable. Take this out if all uploads are perserved.
			$this->old_history = TRUE;
		}

		$data_left  = $this->_load_compare_render($data_left, CMS_UNIT_COMPARE_LEFT);
		$data_right = $this->_load_compare_render($data_right);

		// TODO: $data object should be a class so we can manage it easily.
		$data = $data_left;

		//Get group
		$data_group = $this->unit_model->get_unit_any($unitid_left);

		//dropdown history
		//$data_history  = $this->unit_model->get_unit_history($data_group->groupid);
		$data->history = $this->unit_model->get_unit_history($data_group);
		$data->history_left  = $unitid_left;
		$data->history_right = $unitid_right;

 		$data->unit_left   = $data_left->unit;
 		$data->unit_right  = $data_right->unit;

 		$data->unit_left->typename   = $data_left->unittypename;
 		$data->unit_right->typename  = $data_right->unittypename;

 		$data->unit_left->unitbody   = $data_left->unitbody;
 		$data->unit_right->unitbody  = $data_right->unitbody;

 		$data->css_title = $this->unit_compare->highlight_title($data_left , $data_right);
 		$data->html = $this->unit_compare->highlight($data_left , $data_right);
		$data->show_dropdowns = $show_dropdowns;
		$data->multi_scroll = $this->config->item('cms_unitcompare_multi_scroll');

		if ( $blocksched_obj = $this->unit_compare->get_blocksched_object() ) {
			$blocksched_obj->prepare_compare_html($data);
		}
		if ( ($obj = osa_3p_load_lib('CMS_3P_LIB_INLINEOBJ', 'CMS_3P_FOLDER_INLINEOBJ')) ) {
			$obj->compare_message($data, $this->old_history);
		}
		$this->load->view('unit/unit_compare_view', $data);
	}

	// Get a unit page for either the right or the left unit. This is the rendered template HTML.
	private function _load_compare_render($data, $compare_flag=FALSE) {
		$data->iseditor = $this->unit_model->iseditor($data->unit->courseid);
		$unit = $data->unit;
		$template = $data->unit->template;

		$unitmain_params =
			array('action'=>CMS_ACTION_READ, 'unitid'=>$unit->id, 'courseid'=>$unit->courseid, 'unittype'=>$unit->type,
					'parentid'=>$unit->parentid, 'unit_template'=>$template, 'use_cssid'=>TRUE );

		// Unitmain gets executed twice (compare 2 unit pages) here so have to reset and reinit on the second run.
		if ( !property_exists($this, 'unitmain') ) {
			$this->load->library('unit/Unitmain', $unitmain_params);
		}
		else {
			// So, this is the 2nd run.
			$this->unitmain->reset();
			$this->unitmain->init($unitmain_params);
		}
		$this->unitmain->old_history($this->old_history);
		$data->unitbody = $this->unitmain->render($data->meta_flag);
		return $data;
	}

}
