<?php
/**
 * unitcopy_model - Model for add/update/delete user
 *
 * @author $Author: dtong $
 * @version $Id: unitcopy_model.php,v 1.6 2012/01/24 14:03:31 dtong Exp $
 * @copyright Copyright (c) 2009, Tiller Software Co., Ltd.
 *
 * TODO: Delete this file.
*/
exit('File unitcopy_model.php is not used and will be deleted.');

class unitcopy_model extends CI_Model {
	function __construct() {
		parent::__construct();
    }

	function get_courseall() {
		$this->db->select('id, name');
	    $this->db->from('course_sis');
	    $this->db->where('enabled',CMS_ADMIN_ENABLE);
	    $this->db->order_by('name');
	    $res = $this->db->get();
			if ( $res->num_rows() <= 0 )
			return FALSE;

		$user = $res->result();
		$result = array();
		foreach($user as $value) {
			$result[$value->id] = $value->name;
		}
		return $result;
	}
	function get_course($courseid) {
		if ( !is_numeric($courseid) )
			return FALSE;
		$this->db->select('id, name');
	    $this->db->from('course_sis');
	  	$this->db->where('id',$courseid);
	    $this->db->order_by('name');
	  	 $res = $this->db->get();
			if ( $res->num_rows() <= 0 )
			return FALSE;

		return $res->result();
	}

	function insert($courseid, $unit) {
		if ( !is_numeric($courseid) || is_array($unit) == FALSE )
			return FALSE;

		$tbunit = $this->db->dbprefix('unit');

		$wherein = implode(",", $unit);

		$fields  = "courseid, origunitid, editunitid, currentunitid, groupid, course_intid, ";
		$fields .= "lasteditorid, creatorid, type, status, ";
		$fields .= "startdate, enddate, createdate, editdate, modifydate, archivedate,";
		$fields .= "version, title, description";

		$sql_ins = "INSERT INTO $tbunit ($fields, parentid)  ";
	    //$courseid as $fields for set target courseid to new unit
		$sql_sel = "SELECT $courseid as $fields, parentid FROM $tbunit WHERE id in ($wherein)";
	 	$res     = $this->db->query($sql_ins . $sql_sel);
		/*if ($res != FALSE) {
			$sql_upd = "UPDATE $tbunit SET groupid=id WHERE groupid in ($wherein) and courseid=$courseid and groupid != id";
			$res     = $this->db->query($sql_upd);
		}
		*/

		$this->db->select('u.id, u.parentid, o.id oldunitid');
	    $this->db->from('unit u');
	    $this->db->join('unit o','o.groupid = u.parentid and o.groupid != o.id','left');
		$this->db->where_in('u.parentid',$wherein);
		$this->db->order_by('u.parentid');
		$res = $this->db->get();
		if ( $res->num_rows() <= 0 )
			return FALSE;
		$resobj = $res->result();

		if ($res != FALSE) {
			$sql_upd = "UPDATE $tbunit SET groupid=id WHERE groupid in ($wherein) and courseid=$courseid and groupid != id";
			$res     = $this->db->query($sql_upd);
		}

		$lastparentid = '';
		foreach ($resobj as $row) {
			if ($lastparentid == '')
			    $lastparentid =  $row->parentid;

			if ($lastparentid != $row->parentid) {
			    $lastparentid =  $row->parentid;

			    $wherein = implode(",", $temp);
				$sql_ins = "INSERT INTO $tbunit ($fields, parentid)  ";
				$sql_sel = "SELECT $fields, $row->oldunitid as parentid FROM $tbunit WHERE id in ($wherein)";
				$res     = $this->db->query($sql_ins . $sql_sel);
				if ($res != FALSE) {
					$sql_upd = "UPDATE $tbunit SET groupid=id WHERE groupid in ($wherein) and groupid != id";
					$res     = $this->db->query($sql_upd);
				}

			    $temp = array();
			}

			$temp[] = $row->id;
		}

		if (count($temp) != 0) {
			$wherein = implode(",", $temp);
			$sql_ins = "INSERT INTO $tbunit ($fields, parentid)  ";
			$sql_sel = "SELECT $fields, $row->oldunitid as parentid FROM $tbunit WHERE id in ($wherein)";
			$res     = $this->db->query($sql_ins . $sql_sel);
			if ($res != FALSE) {
				$sql_upd = "UPDATE $tbunit SET groupid=id WHERE groupid in ($wherein) and groupid != id";
				$res     = $this->db->query($sql_upd);
			}
		}


		 return FALSE;
	}


}
?>