<?php
/**
 * general_lang.php - General language file
 *
 * @author $Author: dtong $
 * @version $Id: general_lang.php,v 1.30 2012/05/10 13:03:23 dtong Exp $
 * @copyright Copyright (c) 2009, Tiller Software Co., Ltd.
*/

static $s_general_lang = array(
	'gen_no_permission_ajaxmsg' => "Sorry, you don't have permission to perform this task.",
	'gen_js_ajaxservererror' => 'An error has occurred while accessing the server',
	'gen_js_ajaxclienterror' =>
		'Failed to connect with the server.<br /><br />Please check your internet connection or restart your web browser and try again.',
	'gen_js_ajaxsessiontimeoutmsg' => 'Your session has timed out.<br />You will be redirected to the login page in 10 seconds.',
	'gen_internalservererror' => 'Internal Server Error.',
	'gen_cancelinputmsg' => 'Are you sure to cancel your input?',
	'gen_closebutton' => 'Close',
	'gen_redirectbutton' => 'Go To Login Page Now',
	'gen_more_help_soon' => 'More help files coming soon!',
	'gen_pdf_wait_msg' => 'Generating PDF document. Please wait.',
	'gen_pdf_failed_msg' => 'Sorry, failed to generate PDF document.\n\nPlease notify your IT administrator.',
	'gen_pdf_failed_msg_inpdf' => 'Sorry, this is an incomplete PDF document request. <br /><br />The PDF generation was aborted.',
	'gen_pdf_invalid_request' => 'Invalid PDF request, aborted.',
	'gen_radio_update_error_msg' => 'System error, please logout and try again.',
	'gen_sort_button_up' => 'Up',
	'gen_sort_button_down' => 'Down',
	// For jscript and can't break the long line.
	'gen_javascript_error' =>
		'Web browser Javascript error. Please restart your browser, clean your browser cache and try again.\n\nIf you are running a non-standard browser then please try one of the approved browsers.',
	'gen_maintenance_msg' => 'This site is currently in maintenance mode.<br />No users are allowed to login.',
	'gen_maintenance_ajaxmsg' => 'System is in maintenance mode.<br />You will be redirected to the login page in 10 seconds.',

	'gen_siteres_edit' => 'Turn editing on',
	'gen_siteres_done' => 'Done',
	'gen_siteres_title' => 'Site Resources',

	'gen_cal_jan' => 'Jan',
	'gen_cal_feb' => 'Feb',
	'gen_cal_mar' => 'Mar',
	'gen_cal_apr' => 'Apr',
	'gen_cal_may' => 'May',
	'gen_cal_jun' => 'Jun',
	'gen_cal_jul' => 'Jul',
	'gen_cal_aug' => 'Aug',
	'gen_cal_sep' => 'Sep',
	'gen_cal_oct' => 'Oct',
	'gen_cal_nov' => 'Nov',
	'gen_cal_dec' => 'Dec',

	'gen_search_session_timedout' =>
		'Sorry, a minor conflict has been detected and the page requested can not be displayed
	 	This is due to having TODCM running in two separate browser windows/tabs.
		This is a non-critical error and no data has been lost. Please continue your work on the site.',
	'gen_pdf_generated' => "Generated on:",
	'gen_template_page_title' => 'Page:',

	'gen_security_error' => '<div class="buildererror">Template secuirty session error. Please notify your system administrator.</div>',
	'gen_security_bad_param_error' =>
	'<div class="buildererror">Invalid security internal parameters. Please notify your system administrator.</div>',
	'gen_btnsort_error' => 'Sorry, failed to sort data.<br /><br />This can be caused by another user had deleted the item before you were trying to sort.',
	'gen_security_no_permission' =>
		'Sorry, you don\'t have permission to perform this action.<br /><br />
		This can be caused by having 2 browsers opened at the same time and one of them has been idled too long.<br /><br />
		The "login as" function can also cause this error with 2 active browsers.',
	'gen_security_guest_not_allowed' => 'Sorry, guest users are not allowed to access this area of the site.',
	'gen_invalid_request' => 'Invalid request URL, aborted.<br /><br />Please refresh your browser and try again.'
);

$lang = &$s_general_lang;
