<?php
/**
 * handle_valid_3p_uph.php - Check if a 3rd party uph handle exists.
 *
 * @author $Author: dtong $
 * @version $Id: handle_valid_3p_module.php,v 1.1 2011/11/11 10:17:21 dtong Exp $
 * @copyright Copyright (c) 2011, Tiller Software Co., Ltd.
*/
require_once('handle_base.php');

class handle_valid_3p_module extends handle_base {
	Const HANDLE_PARAM_LIST = '_module';

	function invoke() {
		//Check the handle parameters from the template and make sure they are valid
		//Browser would get error message if invalid parameter is found
		$this->valid_handle_params(self::HANDLE_PARAM_LIST);
		$module = osa_value($this->handle_data, '_module', FALSE);
		return osa_3p_valid_uph($module, FALSE);
	}
}